
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   12:26:33 08/11/2005
-- Design Name:   monitor
-- Module Name:   monitor_tb.vhd
-- Project Name:  dccv5
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: monitor
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY monitor_tb_vhd IS
END monitor_tb_vhd;

ARCHITECTURE behavior OF monitor_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT monitor
	PORT(
		reset : IN std_logic;
		clk : IN std_logic;
      run: in STD_LOGIC;
		w_data : IN std_logic_vector(31 downto 0);
		n_strobe : IN std_logic;
		wr_scale : IN std_logic;
		rd_scale : IN std_logic;
		inc_ddr_pa : IN std_logic;
		rd_mon_wc : IN std_logic;
		mon_re : IN std_logic;
		ddr_pa : IN std_logic_vector(6 downto 0);
		slink_we : IN std_logic;
		slink_data : IN std_logic_vector(35 downto 0);          
		r_data : OUT std_logic_vector(31 downto 0);
      catch_offset: out STD_LOGIC;
		mon_buf_empty : OUT std_logic;
		mon_buf_full : OUT std_logic;
		mon_avl : OUT std_logic;
		mon_we : OUT std_logic;
		mon_data : OUT std_logic_vector(33 downto 0);
		mon_wp : OUT std_logic_vector(6 downto 0);
		inc_mon_cntr : OUT std_logic
		);
	END COMPONENT;
	constant clk_period : time := 7.8 ns;
	SIGNAL cnt :  std_logic_vector(15 downto 0) := (others=>'0');
	SIGNAL cntr :  std_logic_vector(15 downto 0) := (others=>'0');

	--Inputs
	SIGNAL reset :  std_logic := '0';
	SIGNAL clk :  std_logic := '0';
	SIGNAL run :  std_logic := '1';
	SIGNAL n_strobe :  std_logic := '0';
	SIGNAL wr_scale :  std_logic := '0';
	SIGNAL rd_scale :  std_logic := '0';
	SIGNAL inc_ddr_pa :  std_logic := '0';
	SIGNAL rd_mon_wc :  std_logic := '0';
	SIGNAL mon_re :  std_logic := '0';
	SIGNAL slink_we :  std_logic := '0';
	SIGNAL w_data :  std_logic_vector(31 downto 0) := x"00ff0000";
	SIGNAL ddr_pa :  std_logic_vector(6 downto 0) := (others=>'0');
	SIGNAL slink_data :  std_logic_vector(35 downto 0) := x"000008000";

	--Outputs
	SIGNAL r_data :  std_logic_vector(31 downto 0);
	SIGNAL mon_buf_empty :  std_logic;
	SIGNAL mon_buf_full :  std_logic;
	SIGNAL mon_avl :  std_logic;
	SIGNAL mon_we :  std_logic;
	SIGNAL mon_data :  std_logic_vector(33 downto 0);
	SIGNAL mon_wp :  std_logic_vector(6 downto 0);
	SIGNAL inc_mon_cntr :  std_logic;
	SIGNAL catch_offset :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: monitor PORT MAP(
		reset => reset,
		clk => clk,
		run => run,
		w_data => w_data,
		r_data => r_data,
		n_strobe => n_strobe,
		wr_scale => wr_scale,
		rd_scale => rd_scale,
		mon_buf_empty => mon_buf_empty,
		mon_buf_full => mon_buf_full,
		inc_ddr_pa => inc_ddr_pa,
		rd_mon_wc => rd_mon_wc,
		mon_re => mon_re,
		mon_avl => mon_avl,
		mon_we => mon_we,
		mon_data => mon_data,
		mon_wp => mon_wp,
		ddr_pa => ddr_pa,
		catch_offset => catch_offset,
		inc_mon_cntr => inc_mon_cntr,
		slink_we => slink_we,
		slink_data => slink_data
	);

   clk <= not clk after clk_period/2;
	process(clk)
	begin
	  if(clk'event and clk = '1')then
	      cnt <= cnt + 1;
	      if((cnt > x"0012" and cnt < x"0093") or (cnt > x"00a0" and cnt < x"0121"))then
			  slink_we <= '1';
	      else
			  slink_we <= '0';
	      end if;
	      if(cnt = x"0013" or cnt = x"00a1")then
	        slink_data(35 downto 32) <= x"2";
	      elsif(cnt = x"0092" or cnt = x"0120")then
	        slink_data(35 downto 32) <= x"1";
			else
	        slink_data(35 downto 32) <= x"0";
	      end if;
	      if(slink_we = '1')then
	        slink_data(31 downto 0) <= slink_data(31 downto 0) + 1;
	      end if;
	    n_strobe <= not n_strobe;
		 if(n_strobe = '0')then
	      cntr <= cntr + 1;
	      if(cntr = x"0001")then
	        reset <= '1';
	      else
	        reset <= '0';
	      end if;
	      if(cntr = x"0008")then
	        wr_scale <= '1';
	      else
	        wr_scale <= '0';
	      end if;
		 end if;
	    if(cnt = x"009e" and n_strobe = '0')then
			mon_re <= '1';
	    else
			mon_re <= '0';
	    end if;
	  end if;
	end process;

END;
