
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   11:47:54 12/30/2006
-- Design Name:   sdram_ctl
-- Module Name:   C:/iseproj/dccv2c/sdram_test.vhd
-- Project Name:  dccv2c
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: sdram_ctl
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee,mylib;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
use mylib.dcc_pack.all;

ENTITY sdram_test_vhd IS
END sdram_test_vhd;

ARCHITECTURE behavior OF sdram_test_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT sdram_ctl
	PORT(
		reset : IN std_logic;
		mem_test : IN std_logic;
		mem_done : IN std_logic;
		clk : IN std_logic;
		clkn : IN std_logic;
		clk90 : IN std_logic;
		clk270 : IN std_logic;
		not_locked : IN std_logic;
		rd_debug : IN std_logic;
		addr : IN std_logic_vector(13 downto 0);
		n_strobe : IN std_logic;
		flush_cache : IN std_logic;
		rd_ddr_data : IN std_logic;
		cache_chk : IN std_logic;
		ddr_pa : IN std_logic_vector(6 downto 0);
		ddr_wfifo_we : IN std_logic;
		ddr_w_req : IN std_logic;
		ddr_w_length : IN std_logic_vector(5 downto 0);
		ddr_w_addr : IN std_logic_vector(20 downto 0);
		ddr_w_data : IN std_logic_vector(31 downto 0);
		htr_buf_req : IN std_logic;
		htr_buf_addr : IN std_logic_vector(14 downto 0);
		htr_buf_length : IN std_logic_vector(5 downto 0);
		htr_buf_re : IN std_logic;    
		ram_pads : INOUT ram_pad;      
		mem_fail : OUT std_logic;
		chk_done : OUT std_logic;
		r_data : OUT std_logic_vector(31 downto 0);
		cache_hit : OUT std_logic;
		ddr_w_gnt : OUT std_logic;
		htr_buf_gnt : OUT std_logic;
		htr_buf_data : OUT std_logic_vector(31 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL reset :  std_logic := '1';
	SIGNAL mem_test :  std_logic := '0';
	SIGNAL mem_done :  std_logic := '0';
	SIGNAL clk :  std_logic := '0';
	SIGNAL clkn :  std_logic := '1';
	SIGNAL clk90 :  std_logic := '0';
	SIGNAL clk270 :  std_logic := '0';
	SIGNAL not_locked :  std_logic := '1';
	SIGNAL rd_debug :  std_logic := '0';
	SIGNAL n_strobe :  std_logic := '0';
	SIGNAL flush_cache :  std_logic := '0';
	SIGNAL rd_ddr_data :  std_logic := '0';
	SIGNAL cache_chk :  std_logic := '0';
	SIGNAL ddr_wfifo_we :  std_logic := '0';
	SIGNAL ddr_w_req :  std_logic := '0';
	SIGNAL htr_buf_req :  std_logic := '0';
	SIGNAL htr_buf_re :  std_logic := '0';
	SIGNAL addr :  std_logic_vector(13 downto 0) := (others=>'0');
	SIGNAL ddr_pa :  std_logic_vector(6 downto 0) := (others=>'0');
	SIGNAL ddr_w_length :  std_logic_vector(5 downto 0) := "000000";
	SIGNAL ddr_w_addr :  std_logic_vector(20 downto 0) := (others=>'0');
	SIGNAL ddr_w_data :  std_logic_vector(31 downto 0) := (others=>'0');
	SIGNAL htr_buf_addr :  std_logic_vector(14 downto 0) := (others=>'0');
	SIGNAL htr_buf_length :  std_logic_vector(5 downto 0) := (others=>'0');

	--BiDirs
	SIGNAL ram_pads :  ram_pad;

	--Outputs
	SIGNAL mem_fail :  std_logic;
	SIGNAL chk_done :  std_logic;
	SIGNAL r_data :  std_logic_vector(31 downto 0);
	SIGNAL cache_hit :  std_logic;
	SIGNAL ddr_w_gnt :  std_logic;
	SIGNAL htr_buf_gnt :  std_logic;
	SIGNAL htr_buf_data :  std_logic_vector(31 downto 0);

	constant clk_period : time := 7.8 ns;
	signal ras_n: std_logic;
	signal cas_n: std_logic;
	signal we_n: std_logic;
	SIGNAL cnt :  std_logic_vector(15 downto 0) := (others=>'0');
	SIGNAL dqs_cnt :  std_logic_vector(5 downto 0) := (others=>'0');
	signal dm: std_logic;
	signal dqs_pad: std_logic;
	signal ma: std_logic_vector(12 downto 0);
	signal md: std_logic_vector(2 downto 0);
BEGIN
ras_n <= ram_pads.rasn;
cas_n <= ram_pads.casn;
we_n <= ram_pads.wen;
dm <= ram_pads.dm;
ma <= ram_pads.addr;
dqs_pad <= ram_pads.dqs;
md <= ram_pads.data(2 downto 0);
ddr_w_data(2 downto 0) <= cnt(2 downto 0);
ddr_w_addr(0) <= '0';
ram_pads.dqs <= clk270 when dqs_cnt > "100010" and dqs_cnt < "110011" else
     '0' when dqs_cnt = "100010" or dqs_cnt = "110011" else 'Z';
	-- Instantiate the Unit Under Test (UUT)
	uut: sdram_ctl PORT MAP(
		reset => reset,
		mem_test => mem_test,
		mem_done => mem_done,
		mem_fail => mem_fail,
		chk_done => chk_done,
		clk => clk,
		clkn => clkn,
		clk90 => clk90,
		clk270 => clk270,
		not_locked => not_locked,
		r_data => r_data,
		rd_debug => rd_debug,
		addr => addr,
		n_strobe => n_strobe,
		flush_cache => flush_cache,
		rd_ddr_data => rd_ddr_data,
		cache_chk => cache_chk,
		cache_hit => cache_hit,
		ddr_pa => ddr_pa,
		ddr_w_gnt => ddr_w_gnt,
		ddr_wfifo_we => ddr_wfifo_we,
		ddr_w_req => ddr_w_req,
		ddr_w_length => ddr_w_length,
		ddr_w_addr => ddr_w_addr,
		ddr_w_data => ddr_w_data,
		htr_buf_req => htr_buf_req,
		htr_buf_gnt => htr_buf_gnt,
		htr_buf_addr => htr_buf_addr,
		htr_buf_length => htr_buf_length,
		htr_buf_re => htr_buf_re,
		htr_buf_data => htr_buf_data,
		ram_pads => ram_pads
	);

   clk <= not clk after clk_period/2;
	clkn <= not clk;
	clk90 <= clk after clk_period/4;
	clk270 <= not clk90;
	process(clk270)
	begin
	  if(clk270'event and clk270 = '1')then
	    if(ras_n = '1' and cas_n = '0' and we_n = '1')then
		   dqs_cnt <= "100000";
		 elsif(dqs_cnt(5) = '1')then
		   dqs_cnt <= dqs_cnt + 1;
		 end if;
	  end if;
	end process;
	process(clk)
	begin
	  if(clk'event and clk = '1')then
	    n_strobe <= not n_strobe;
		 if(n_strobe = '0')then
	      if(cnt = x"3820" or cnt = x"3850")then
--	        is_high <= not is_high;
	        cache_chk <= '1';
	      else
--			  is_high <= '0';
	        cache_chk <= '0';
	      end if;
	      cnt <= cnt + 1;
	      if(cnt = x"0010")then
	        reset <= '0';
	        not_locked <= '0';
			  mem_test <= '1';
			elsif(mem_fail = '1')then
--			  mem_test <= '0';
	      end if;
		 end if;
	    if(cnt > x"389a" and cnt < x"389f")then
			ddr_wfifo_we <= not n_strobe;
	    else
		 	ddr_wfifo_we <= '0';
	    end if;
	    if(cnt = x"3e20" and n_strobe = '0')then
			ddr_w_req <= '1';
	    else
		 	ddr_w_req <= '0';
	    end if;
	  end if;
	end process;
	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;

		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
